#include     "UGAlib.mqh"
#include     "MustHave.mqh"
#include     "StrategyMA.mqh"                                        // 0 -  
#include     "StrategySAR.mqh"                                       // 1 -  SAR
#include     "StrategyStoch.mqh"                                     // 2 - 

double       cap=10000.0;                                            // 
long         leverage;                                               // 
double       contractSize;                                           // 
int          z;                                                      //       

double       ERROR=0.0;                                              //    (   ,...
                                                                     //...  )

void FitnessFunction(int chromos)                                    //-   :...
                                                                     //... , ,  ,...
                                                                     //...  ;...
                                                                     //...  -, ...
                                                                     //...     
{
  double ff=0.0;                                                     // -
  strat=(int)MathRound(Colony[GeneCount-2][chromos]*StratCount);     //  
//        ...
  z=(int)MathRound(Colony[GeneCount-1][chromos]*3);                  //  
  switch(z)
  {
    case  0: {s="EURUSD"; break;};
    case  1: {s="GBPUSD"; break;};
    case  2: {s="USDCHF"; break;};
    case  3: {s="USDJPY"; break;};
    default: {s="EURUSD"; break;};
  }
//..      ,    (     MarketWatch)
/*
  z=(int)MathRound(Colony[GeneCount-1][chromos]*(SymbolsTotal(true)-1));//  
  s=SymbolName(z,true);
*/
  optF=Colony[GeneCount][chromos];                                   //   
  switch(strat)
  {
    case  0: {ff=FFMA(   Colony[1][chromos],                         //  case     
                         Colony[2][chromos],
                         Colony[3][chromos],
                         Colony[4][chromos],
                         Colony[5][chromos]); break;};
    case  1: {ff=FFSAR(  Colony[1][chromos],
                         Colony[2][chromos],
                         Colony[3][chromos],
                         Colony[4][chromos],
                         Colony[5][chromos]); break;};
    case  2: {ff=FFStoch(Colony[1][chromos],
                         Colony[2][chromos],
                         Colony[3][chromos],
                         Colony[4][chromos],
                         Colony[5][chromos]); break;};
    default: {ff=FFMA(   Colony[1][chromos],
                         Colony[2][chromos],
                         Colony[3][chromos],
                         Colony[4][chromos],
                         Colony[5][chromos]); break;};
  }
  AmountStartsFF++;
  Colony[0][chromos]=ff;
  Print(TimeToString(TimeCurrent()),";","GAModule:FitnessFunction",
        ";","strat=",strat,";","s=",s,";","optF=",optF,
        ";",Colony[1][chromos],";",Colony[2][chromos],";",Colony[3][chromos],";",Colony[4][chromos],";",Colony[5][chromos]);
}

void ServiceFunction()
{ 
}

void GA()                                                            //    
{
  GeneCount      =OptParamCount+3;                                   //-  ( -   ,...
                                                                     //... 3   , ,  ;...
                                                                     //...       FitnessFunction())
  ChromosomeCount=GeneCount*11;                                      //-   
  RangeMinimum   =0.0;                                               //  
  RangeMaximum   =1.0;                                               //  
  Precision      =0.0001;                                            // 
  OptimizeMethod =2;                                                 //1-,  -
  ArrayResize    (Chromosome,GeneCount+1);
  ArrayInitialize(Chromosome,0);
  Epoch          =100;                                               //-   
  UGA(100.0,1.0,1.0,1.0,1.0,0.5,1.0);                                // ,  ,  ,  , ,    ,      %
}

void GetTrainResults()                                               //  
{
  strat=(int)MathRound(Chromosome[GeneCount-2]*StratCount);          //  
//        ...
  z=(int)MathRound(Chromosome[GeneCount-1]*3);                       //  
  switch(z)
  {
    case  0: {s="EURUSD"; break;};
    case  1: {s="GBPUSD"; break;};
    case  2: {s="USDCHF"; break;};
    case  3: {s="USDJPY"; break;};
    default: {s="EURUSD"; break;};
  }
//..      ,    (     MarketWatch)
/*
  z=(int)MathRound(Chromosome[GeneCount-1]*(SymbolsTotal(true)-1));  //  
  s=SymbolName(z,true);
*/
  optF=Chromosome[GeneCount];                                        //   
  switch(strat)
  {
    case  0: {GTRMA(   Chromosome[1],                                //  case     
                       Chromosome[2],
                       Chromosome[3],
                       Chromosome[4],
                       Chromosome[5]) ; break;};
    case  1: {GTRSAR(  Chromosome[1],
                       Chromosome[2],
                       Chromosome[3],
                       Chromosome[4],
                       Chromosome[5]) ; break;};
    case  2: {GTRStoch(Chromosome[1],
                       Chromosome[2],
                       Chromosome[3],
                       Chromosome[4],
                       Chromosome[5]) ; break;};
    default: {GTRMA(   Chromosome[1],
                       Chromosome[2],
                       Chromosome[3],
                       Chromosome[4],
                       Chromosome[5]) ; break;};
  }
  Print(TimeToString(TimeCurrent()),";","GAModule:GetTrainResults",
        ";","strat=",strat,";","s=",s,";","optF=",optF,
        ";",Chromosome[1],";",Chromosome[2],";",Chromosome[3],";",Chromosome[4],";",Chromosome[5]);
}